<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      window.previousPairs = [];

      function getPairs() {
        const form = document.getElementById("form");
        return [...new FormData(form).values()].filter(
          (pair) =>
            pair.length === 6 &&
            (pair.endsWith("USD") || pair.startsWith("USD"))
        );
      }

      function connect() {
        try {
          ws.close();
        } catch (e) {}
        const pairs = getPairs();
        window.previousPairs = pairs;
        const form = document.getElementById("form");
        const historicalDataRange = form.elements.getHistory.checked;
        window.ws = new WebSocket(
          `ws://localhost:8080/subscribe?pairs=${pairs.join(",")}${
            historicalDataRange
              ? `&from=${form.elements.from.value}&to=${form.elements.to.value}`
              : ""
          }`
        );
        const div = document.getElementById("div");
        ws.addEventListener("message", (ev) => {
          const data = JSON.parse(ev.data);
          console.log(ev.data, data);
          const newDiv = document.createElement("div");
          newDiv.innerText = JSON.stringify(data);
          div.prepend(newDiv);
        });
      }

      function send(message) {
        ws.send(JSON.stringify(message));
      }

      function handleChange() {
        const pairs = getPairs();
        if (window.ws) {
          if (pairs.length > previousPairs.length) {
            const form = document.getElementById("form");
            const historicalDataRange = form.elements.getHistory.checked
              ? {
                  from: form.elements.from.value,
                  to: form.elements.to.value,
                }
              : {};
            send({
              type: "subscribe",
              pair: pairs.find((pair) => !previousPairs.includes(pair)),
              ...historicalDataRange,
            });
          } else {
            send({
              type: "unsubscribe",
              pair: previousPairs.find((pair) => !pairs.includes(pair)),
            });
          }

          window.previousPairs = pairs;
        }
      }
    </script>
    <form
      id="form"
      onchange="handleChange()"
      onsubmit="connect(); return false"
    >
      <label
        ><input type="checkbox" name="GBPUSD" value="GBPUSD" />GBPUSD</label
      >
      <label
        ><input type="checkbox" name="EURUSD" value="EURUSD" />EURUSD</label
      >
      <label
        ><input type="checkbox" name="USDCHF" value="USDCHF" />USDCHF</label
      >
      <label
        ><input type="checkbox" name="XAUUSD" value="XAUUSD" />XAUUSD</label
      >
      <label
        ><input type="checkbox" name="getHistory" value="getHistory" />Get
        History</label
      >
      <input name="from" value="2020-11-23" />
      <input name="to" value="2020-11-30" />
      <button id="connect-button" type="submit">Connect</button>
    </form>
    <div id="div"></div>
  </body>
</html>
